diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 8c5147655..b710ae394 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -271,11 +271,6 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         }
     }
 
-    @Override
-    public boolean getImmovable() {
-        return this.block.immovable;
-    }
-
     @Override
     public float getBlastResistance(final @Nullable Entity entity) {
         return this.block.blastResistance / 5f;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
index 93f4ffb1d..f8fe18d53 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
@@ -82,11 +82,6 @@ public class BlockLogicAir
         return 0.0f;
     }
 
-    @Override
-    public boolean getImmovable() {
-        return false;
-    }
-
     @Override
     public float getBlastResistance(final @Nullable Entity entity) {
         return 0.0f;
@@ -121,4 +116,9 @@ public class BlockLogicAir
     public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
+
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        return Material.PISTON_DESTROY_ON_PUSH;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
index f436e5c64..2b53b79d0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
@@ -34,4 +34,9 @@ public class BlockLogicBedrock
         final var thatguy = world.getClosestPlayerToEntity(thisguy, 16D);
         if (thatguy != null) thisguy.hurt(thatguy, 1, DamageType.GENERIC);
     }
+
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        return Material.PISTON_CANT_PUSH;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java
index 84c3ebcb3..905f1514f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java
@@ -34,7 +34,7 @@ public class BlockLogicBonePile
         return switch (dropCause) {
             case SILK_TOUCH, PICK_BLOCK -> new ItemStack[] { new ItemStack(this) };
             default -> {
-                int dropChance = 5;
+                int dropChance = 4;
                 if (world.rand.nextInt(dropChance) == 0) {
                     yield new ItemStack[] { new ItemStack(Items.BONE, 1) };
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
index deba70176..4924b90f7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
@@ -30,4 +30,9 @@ public class BlockLogicBoneShale
             return player.getCurrentPlayerStrVsBlock(this.block) / blockHardness / 30F;
         }
     }
+
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        return Material.PISTON_CANT_PUSH;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java
index 4c551034a..72ba7bf14 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -37,7 +38,13 @@ public class BlockLogicBoulderMagmatic extends BlockLogicFlower {
 	public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, @Nullable TileEntity tileEntity) {
 		return switch (dropCause) {
 			case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
-			default -> null;
+			default -> {
+				final int pebbles = 1 + world.rand.nextInt(2);
+				if (world.rand.nextInt(4) == 0) {
+					yield new ItemStack[]{new ItemStack(Items.AMMO_PEBBLE, pebbles), new ItemStack(Items.NETHERCOAL)};
+				}
+				yield new ItemStack[]{new ItemStack(Items.AMMO_PEBBLE, pebbles)};
+			}
 		};
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java
index 5fcbe3029..6791d070b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java
@@ -1,9 +1,14 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicBoulderSulfuric extends BlockLogicBoulderMagmatic {
 	public BlockLogicBoulderSulfuric(@NotNull Block<?> block) {
@@ -11,6 +16,20 @@ public class BlockLogicBoulderSulfuric extends BlockLogicBoulderMagmatic {
 		this.setBlockBounds(0.1F, 0.0F, 0.1F, 0.9F, 0.8F, 0.9F);
 	}
 
+	@Override
+	public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, @Nullable TileEntity tileEntity) {
+		return switch (dropCause) {
+			case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
+			default -> {
+				final int pebbles = 1 + world.rand.nextInt(2);
+				if (world.rand.nextInt(4) == 0) {
+					yield new ItemStack[]{new ItemStack(Items.AMMO_PEBBLE, pebbles), new ItemStack(Items.SULFUR)};
+				}
+				yield new ItemStack[]{new ItemStack(Items.AMMO_PEBBLE, pebbles)};
+			}
+		};
+	}
+
 	@Override
 	public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
 		entity.maxFireTicks = 100;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 84e005a2d..b8add79b1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -342,7 +342,7 @@ public class BlockLogicButton
 
     @Override
     public boolean canBePainted() {
-        return this.id() == Blocks.BUTTON_PLANKS.id();
+        return this.id() == Blocks.BUTTON_PLANKS_OAK.id();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
index b899abe2b..72252d6e2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
@@ -12,7 +12,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicButtonPainted
-    extends BlockLogicButtonPlanks
+    extends BlockLogicButtonPlanksOak
     implements IPainted {
     public static final int MASK_COLOR = 0b1111_0000;
 
@@ -47,7 +47,7 @@ public class BlockLogicButtonPainted
 
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.setBlockTypeNotify(tilePos, Blocks.BUTTON_PLANKS);
+        world.setBlockTypeNotify(tilePos, Blocks.BUTTON_PLANKS_OAK);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanksOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanksOak.java
new file mode 100644
index 000000000..d8d4ad263
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanksOak.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import org.jetbrains.annotations.NotNull;
+
+public class BlockLogicButtonPlanksOak
+    extends BlockLogicButton {
+
+    public BlockLogicButtonPlanksOak(final @NotNull Block<?> block) {
+        super(block);
+    }
+
+    @Override
+    public int tickDelay() {
+        return 10;
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 9372320e5..53b5267a0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -224,7 +224,14 @@ public class BlockLogicFire
     private void checkBurn(final @NotNull World world, final @NotNull TilePos tilePos, final int chance, final @NotNull Random random, final int meta) {
         if (!world.getGameRuleValue(GameRules.DO_FIRE_SPREAD)) return;
         if (random.nextInt(chance) < burnChance[world.getBlockType(tilePos).id()]) {
-            final boolean isTNT = world.getBlockType(tilePos) == Blocks.TNT;
+            final Block<?> targetBlock = world.getBlockType(tilePos);
+            final boolean isTNT = targetBlock == Blocks.TNT;
+
+            // Logs should always scorch when they burn, never convert into a fire block first.
+            if (targetBlock.getLogic() instanceof BlockLogicLog) {
+                this.setBurnResult(world, tilePos);
+                return;
+            }
 
             if (random.nextInt(meta + 10) < 5 && !world.isBlockBeingRainedOn(tilePos)) {
                 if (this.getBurnResult(world, tilePos) == Blocks.AIR /* Fix for fire destroying moss blocks */) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
index be61c32b0..a2371a7ec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
@@ -1,10 +1,16 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.ItemCoal;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicLog extends BlockLogicAxisAligned {
 
@@ -12,6 +18,17 @@ public class BlockLogicLog extends BlockLogicAxisAligned {
         super(block, Materials.WOOD);
     }
 
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        if (this.block == Blocks.LOG_SCORCHED) {
+            return switch (dropCause) {
+                case PISTON_CRUSH -> new ItemStack[] { new ItemStack(Items.COAL, 1, ItemCoal.META_CHARCOAL) };
+                default -> new ItemStack[] { new ItemStack(this.block) };
+            };
+        }
+        return super.getBreakResult(world, dropCause, data, tileEntity);
+    }
+
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         byte r = 4;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index e2ffc3aff..6b3582219 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -94,4 +95,9 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
         }
         return null;
     }
+
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        return Material.PISTON_CANT_PUSH;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicObsidian.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicObsidian.java
new file mode 100644
index 000000000..4b99b63d3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicObsidian.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.block;
+
+import org.jetbrains.annotations.NotNull;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+
+public class BlockLogicObsidian extends BlockLogic {
+    public BlockLogicObsidian(@NotNull Block<?> block) {
+        super(block, Materials.STONE);
+    }
+
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        return Material.PISTON_CANT_PUSH;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index d65472331..de4c866ce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -426,4 +427,9 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
 
     public record Bounds(@NotNull Axis axis, @NotNull TilePos pos, int maxBoundA, int maxBoundB) {
     }
+
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        return Material.PISTON_CANT_PUSH;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 687a4a1fb..3995f8013 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -56,7 +56,7 @@ public class BlockLogicStatue extends BlockLogic {
         // Sneaking overrides all - next pose
         if (player.isSneaking()) {
             statueEntity.nextPose();
-            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.4F);
+            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.4F);
             return true;
         }
 
@@ -148,7 +148,7 @@ public class BlockLogicStatue extends BlockLogic {
 
         // All else fails - next pose
         statueEntity.nextPose();
-        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "scrape", 1.0F, 0.15F + world.rand.nextFloat() * 0.7F);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.scrape", 1.0F, 0.15F + world.rand.nextFloat() * 0.7F);
         return true;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index b196dfd0f..5bfa788ba 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -345,8 +345,8 @@ public final class Blocks {
         .withSound(BlockSounds.PERMAFROST).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-    public static final @NotNull Block<?> OBSIDIAN = register("obsidian", "minecraft:block/obsidian", 180, (b) -> new BlockLogic(b, Materials.STONE))
-        .withSound(BlockSounds.STONE).withHardness(10F).withBlastResistance(2000F).withOverrideColor(MaterialColor.paintedBlack).withImmovableFlagSet()
+    public static final @NotNull Block<?> OBSIDIAN = register("obsidian", "minecraft:block/obsidian", 180, (b) -> new BlockLogicObsidian(b))
+        .withSound(BlockSounds.STONE).withHardness(10F).withBlastResistance(2000F).withOverrideColor(MaterialColor.paintedBlack)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PISTON_CRUSHING);
 
     public static final @NotNull Block<?> GLASS = register("glass", "minecraft:block/glass", 190, (b) -> new BlockLogicGlass(b, Materials.GLASS))
@@ -425,10 +425,10 @@ public final class Blocks {
         .withOverrideColor(MaterialColor.stone);
 
     public static final @NotNull Block<?> BEDROCK = register("bedrock", "minecraft:block/bedrock", 260, (b) -> new BlockLogicBedrock(b, Materials.STONE))
-        .withSound(BlockSounds.STONE).withSetUnbreakable().withBlastResistance(6000000F).withImmovableFlagSet()
+        .withSound(BlockSounds.STONE).withSetUnbreakable().withBlastResistance(6000000F)
         .withTags(BlockTags.PISTON_CRUSHING, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS);
     public static final @NotNull Block<?> BONESHALE = register("boneshale", "minecraft:block/boneshale", 261, (b) -> new BlockLogicBoneShale(b, Materials.STONE))
-        .withSound(BlockSounds.STONE).withHardness(16F).withBlastResistance(6000000F).withImmovableFlagSet()
+        .withSound(BlockSounds.STONE).withHardness(16F).withBlastResistance(6000000F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN);
 
     public static final @NotNull Block<BlockLogicFluid> FLUID_WATER_FLOWING = register("fluid.water.flowing", "minecraft:block/fluid_water_flowing", 270, (BlockLogicSupplier<BlockLogicFluid>) b -> new BlockLogicFluidFlowing(b, Materials.WATER, new FluidWater(), Blocks.FLUID_WATER_STILL))
@@ -760,7 +760,7 @@ public final class Blocks {
     public static final @NotNull Block<?> BUTTON_STONE = register("button.stone", "minecraft:block/button_stone", 470, BlockLogicButton::new)
         .withSound(BlockSounds.STONE).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
-    public static final @NotNull Block<?> BUTTON_PLANKS = register("button.planks", "minecraft:block/button_planks", 471, BlockLogicButtonPlanks::new)
+    public static final @NotNull Block<?> BUTTON_PLANKS_OAK = register("button.planks", "minecraft:block/button_planks", 471, BlockLogicButtonPlanksOak::new)
         .withSound(BlockSounds.WOOD).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_AXE, BlockTags.PREVENT_MOB_SPAWNS);
     public static final @NotNull Block<BlockLogicButtonPainted> BUTTON_PLANKS_PAINTED = register("button.planks.painted", "minecraft:block/button_planks_painted", 472, BlockLogicButtonPainted::new)
@@ -806,20 +806,20 @@ public final class Blocks {
     public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE = register("piston.base", "minecraft:block/piston_base", 520, (BlockLogicSupplier<BlockLogicPistonBase>)b -> 
         new BlockLogicPistonBase(
             b, PistonCommon.TYPE_NORMAL,
-            (byte)12, (byte)1, EnumDropCause.SILK_TOUCH, false, Double.NaN
+            12, 0, 1, EnumDropCause.SILK_TOUCH, Double.NaN
         ))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE_STICKY = register("piston.base.sticky", "minecraft:block/piston_base_sticky", 521, (BlockLogicSupplier<BlockLogicPistonBase>)b -> 
         new BlockLogicPistonBase(
             b, PistonCommon.TYPE_STICKY,
-            (byte)12, (byte)1, EnumDropCause.SILK_TOUCH, true, Double.NaN
+            12, 12, 1, EnumDropCause.SILK_TOUCH, Double.NaN
         ))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final @NotNull Block<BlockLogicPistonHead> PISTON_HEAD = register("piston.head", "minecraft:block/piston_head", 522, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 4/16d, 4/16d))
-        .withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats().withImmovableFlagSet()
+        .withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final @NotNull Block<BlockLogicPistonMoving> PISTON_MOVING = register("piston.moving", "minecraft:block/piston_moving", 523, BlockLogicPistonMoving::new)
@@ -829,7 +829,7 @@ public final class Blocks {
     public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE_STEEL = register("piston.base.steel", "minecraft:block/piston_base_steel", 524, (BlockLogicSupplier<BlockLogicPistonBase>)b -> 
         new BlockLogicPistonBase(
             b, PistonCommon.TYPE_STEEL,
-            (byte)24, (byte)1, EnumDropCause.PISTON_CRUSH, false, 2.0
+            24, 0, 1, EnumDropCause.PISTON_CRUSH, 2.0
         ))
         .withSound(BlockSounds.METAL)
         .withHardness(5F)
@@ -967,7 +967,7 @@ public final class Blocks {
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.SULFURIC_FIRE_OVERLAY_SOURCE);
 
     public static final @NotNull Block<?> MOBSPAWNER = register("mobspawner", "minecraft:block/mobspawner", 640, BlockLogicMobSpawner::new)
-        .withSound(BlockSounds.METAL).withHardness(5F).withImmovableFlagSet()
+        .withSound(BlockSounds.METAL).withHardness(5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.lapis);
     public static final @NotNull Block<?> MOBSPAWNER_DEACTIVATED = register("mobspawner.deactivated", "minecraft:block/mobspawner_deactivated", 641, BlockLogicMobSpawnerDeactivated::new)
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 0dc111172..18d335387 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -22,8 +22,6 @@ import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-import static net.minecraft.core.world.save.conversion.ItemConverters.legacyBucketConverter;
-
 public class TileEntityBasket extends TileEntity implements ICarrySource {
     private int numUnitsInside = 0;
     private final Object2IntMap<BasketEntry> contents = new Object2IntArrayMap<>();
@@ -170,7 +168,7 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
         if (shouldUpdate) updateNumUnits();
     }
 
-    private boolean importItemStack(final ItemStack stack) {
+    private boolean importItemStack(final @NotNull ItemStack stack) {
         BasketEntry entry = new BasketEntry(stack.itemID, stack.getMetadata(), stack.getData());
         final int sizeUnits = getItemSizeUnits(stack.getItem());
         final int freeUnits = getMaxUnits() - numUnitsInside;
@@ -239,53 +237,46 @@ public class TileEntityBasket extends TileEntity implements ICarrySource {
         return super.pickup(world, holder, tilePos_);
     }
 
-    private static final class BasketEntry {
-        public final int id;
-        public final int metadata;
-        public final CompoundTag tag;
-
-        public BasketEntry(final int id, final int metadata, final CompoundTag tag) {
-            this.id = id;
-            this.metadata = metadata;
-            this.tag = tag;
-        }
+    private record BasketEntry(int id, int metadata, CompoundTag tag) {
 
-        public static BasketEntry read(final CompoundTag tag) {
+        public static @NotNull BasketEntry read(final @NotNull CompoundTag tag) {
 
-            legacyBucketConverter(tag);
+                final int id = tag.getShort("id");
+                final int damage = tag.getShort("Damage");
+                final CompoundTag data = tag.getCompound("Data");
 
-            final int id = tag.getShort("id");
-            final int damage = tag.getShort("Damage");
-            final CompoundTag data = tag.getCompound("Data");
+                return new BasketEntry(id, damage, data);
+            }
 
-            return new BasketEntry(id, damage, data);
-        }
+            public static void write(final @NotNull CompoundTag tag, final @NotNull BasketEntry entry) {
+                tag.putShort("id", (short) entry.id);
+                tag.putShort("Damage", (short) entry.metadata);
+                tag.putCompound("Data", entry.tag);
+            }
 
-        public static void write(final CompoundTag tag, final BasketEntry entry) {
-            tag.putShort("id", (short) entry.id);
-            tag.putShort("Damage", (short) entry.metadata);
-            tag.putCompound("Data", entry.tag);
-        }
+            public Item getItem() {
+                return Item.itemsList[this.id];
+            }
 
-        public Item getItem() {
-            return Item.itemsList[this.id];
-        }
+            private boolean shouldCompareFullTag() {
+                return this.tag.containsKey("State") || this.tag.containsKey("Charges") || this.tag.getValues().size() > 2;
+            }
 
-        @Override
-        public boolean equals(final Object obj) {
-            if (!(obj instanceof BasketEntry)) return false;
-            final BasketEntry other = (BasketEntry) obj;
-            if (this.id != other.id || this.metadata != other.metadata) return false;
-            return this.tag.getValues().size() <= 2 && other.tag.getValues().size() <= 2;
-        }
+            @Override
+            public boolean equals(final Object obj) {
+                if (!(obj instanceof BasketEntry other)) return false;
+                if (this.id != other.id || this.metadata != other.metadata) return false;
+                if (this.shouldCompareFullTag() || other.shouldCompareFullTag()) {
+                    return this.tag.equals(other.tag);
+                }
+                return true;
+            }
 
-        @Override
-        public int hashCode() {
-            if (this.tag.getValues().size() <= 2) {
-                return Objects.hash(this.id, this.metadata);
-            } else {
-                return Objects.hash(this.id, this.metadata, this.tag);
+            @Override
+            public int hashCode() {
+                return this.shouldCompareFullTag()
+                    ? Objects.hash(this.id, this.metadata, this.tag)
+                    : Objects.hash(this.id, this.metadata);
             }
         }
-    }
 }
\ No newline at end of file
